/******************************************************************************
* Copyright (c) 2011, Linear Technology, Corp.                                *
* Linear Tech Proprietary and Confidential                                    *
*                                                                             *
* Title:                                                                      *
* Author:          Gary Yu                                                    *
* Create Date:     10:08:58 09/09/2015                                        *
* Design Name:                                                                *
* Module Name:                                                                *
* Project Name:                                                               *
* Target Devices:                                                             *
* Tool versions:                                                              *
* Description:                                                                *
*                                                                             *
* Dependencies:                                                               *
*                                                                             *
* Revision 1.0     10:08:58 09/09/2015 Gary Yu                                *
* File Created                                                                *
*                                                                             *
* Additional Comments:                                                        *
*                                                                             *
******************************************************************************/
`timescale 1ns / 1ps

module xlbram_a_addr
(
addr_trigger, 
addr,

cnt_done,
cnt_data,

BUFFER_ADDR_CNT,
rst);

 
input         addr_trigger; 
input         cnt_data;
input         rst;

output [17:0] addr;
output        cnt_done;

input  [12:0] BUFFER_ADDR_CNT;

reg    [17:0] addr;
reg           cnt_done;

always @ (posedge addr_trigger or negedge rst)
  if(~rst)
  begin
    addr          <= #1 18'b0;
    cnt_done      <= #1 1'b0;
  end
  else if(cnt_data)
    if(addr == {BUFFER_ADDR_CNT, 5'b11110})
    begin
      cnt_done       <= #1 1'b1;
      addr           <= #1 addr + 1;
    end
    else if ((addr == {BUFFER_ADDR_CNT, 5'b11111}) && cnt_done)
      addr           <= #1 addr;
    else
      addr           <= #1 addr + 1;  
       
endmodule
