/******************************************************************************
* Copyright (c) 2011, Linear Technology, Corp.                                *
* Linear Tech Proprietary and Confidential                                    *
*                                                                             *
* Title:                                                                      *
* Author:          Gary Yu                                                    *
* Create Date:     10:08:58 09/09/2015                                        *
* Design Name:                                                                *
* Module Name:                                                                *
* Project Name:                                                               *
* Target Devices:                                                             *
* Tool versions:                                                              *
* Description:                                                                *
*                                                                             *
* Dependencies:                                                               *
*                                                                             *
* Revision 1.0     10:08:58 09/09/2015 Gary Yu                                *
* File Created                                                                *
*                                                                             *
* Additional Comments:                                                        *
*                                                                             *
******************************************************************************/
`timescale 1ns / 1ps

module xlbram_b_addr #
(
parameter   BRAM_B_ADDR_WIDTH   =    18
)
(
addr_trigger, 
addr,

pre_cnt_done,
cnt_data,

BUFFER_ADDR_CNT,
shift_addr,
rst);

 
input         addr_trigger; 
input         cnt_data;
input         rst;

output [BRAM_B_ADDR_WIDTH - 1:0] addr;
output        pre_cnt_done;

input  [12:0] BUFFER_ADDR_CNT;
input         shift_addr;

    
reg    [BRAM_B_ADDR_WIDTH - 1:0] addr;
reg           pre_cnt_done;
always @ (posedge addr_trigger or negedge rst)
  if(~rst)
  begin
    addr          <= #1 {BRAM_B_ADDR_WIDTH{1'b0}};//18'b0;
    pre_cnt_done  <= #1 1'b0;
  end
  else if(cnt_data)
    if (addr == {BUFFER_ADDR_CNT, {(BRAM_B_ADDR_WIDTH - 13){1'b1}}})
    begin
      addr           <= #1 addr;
      pre_cnt_done       <= #1 1'b1;
    end  
    else
      addr           <= #1 addr + 1; 
  else if(shift_addr)
    addr          <= #1 addr - 1;
  else
    pre_cnt_done      <= #1 1'b0;
      
            
endmodule
